#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main ()
{
  time_t timer;
  struct tm y2k = {0};
  double seconds;
  double min, hora, dia;
  int mesAtual, dias, diaAtual;
  int horaInt, minInt, diaInt;
  int horaAtual, minAtual, segundoAtual;
  int i = 0;
  int ano = 2000;
  int diasMes[12] = {31,28,31,30,31,30,31,31,30,31,30,31};

  y2k.tm_hour = 0;   y2k.tm_min = 0; y2k.tm_sec = 0;
  y2k.tm_year = 100; y2k.tm_mon = 0; y2k.tm_mday = 1;

  time(&timer);  /* get current time; same as: timer = time(NULL)  */

  seconds = difftime(timer,mktime(&y2k));

  printf ("\n\n%.f seconds since January 1, 2000 in the current timezone\n\n", seconds);
  
  min = seconds/60;
  hora = min/60;
  dia = hora/24;
  dias = dia;
  
  while(dias >= 365){
    if ( ( ano % 4 == 0 && ano % 100 != 0 ) || ano % 400 == 0 ){
      ano++;
      dias = dias - 366;
    }
    else{
      ano++;
      dias = dias - 365;
    }	
  }

  if ( ( ano % 4 == 0 && ano % 100 != 0 ) || ano % 400 == 0 )
    diasMes[1] = 29;
  else
    diasMes[1] = 28;

  diaAtual = dias;   
  mesAtual = 0; 

  while(diaAtual > 31){
    
    diaAtual = diaAtual - diasMes[i];  
    mesAtual++;
    i++;
  }

  printf ("\n\nDia: %d do %d de %d\n\n", diaAtual+1, mesAtual+1, ano);

  horaInt = min/60;
  minInt = seconds/60;
  diaInt = hora/24;

  horaAtual = hora - (diaInt * 24);
  minAtual = min - (horaInt * 60);
  segundoAtual = seconds - (minInt * 60);

  printf ("\n\nHoras: %d Horas %d Minutos e %d Segundos\n\n", horaAtual, minAtual, segundoAtual);

  return 0;
}