#include <stdio.h>
#include <unistd.h>
#include <mysql/mysql.h>
#include <time.h>
#include <wiringPi.h>

void main(void){

  //Variaveis para DATA e HORA
  time_t timer;
  struct tm y2k = {0};
  double seconds;
  double min, hora, dia;
  int mesAtual, dias, diaAtual;
  int horaInt, minInt, diaInt;
  int horaAtual, minAtual, segundoAtual;
  int i = 0;
  int ano = 2000;
  int diasMes[12] = {31,28,31,30,31,30,31,31,30,31,30,31};

  y2k.tm_hour = 0;   y2k.tm_min = 0; y2k.tm_sec = 0;
  y2k.tm_year = 100; y2k.tm_mon = 0; y2k.tm_mday = 1;
  //Final das variaveis para DATA e HORA

  //Variaveis para Banco de Dados
	MYSQL conexao;
	MYSQL_RES *resp;
	MYSQL_ROW linhas;
	MYSQL_FIELD *campos;

	int res;
	char query[120];
	char queryConsult[] = "SELECT * FROM tabela";
	int sensor, mes, seg;
	int count;
  //final das variaveis para Banco de Dados

  //Variaveis para LER o SENSOR
  wiringPiSetup();  //Inicializa a wiringPi utilizando a a numeracao de pinos da wiringPi
  pinMode(7,INPUT); //Seta o pino GPIO7 da RaspberryPi como entrada (o pino gpio7 é o pino 7 da wiringPi)
  //Final das variaveis para LER o SENSOR

	mysql_init(&conexao);

	
	if(mysql_real_connect(&conexao,"localhost","guest","guest","sensorIR",0,NULL,0)){ //conecta e verifica conexao
	
	printf("Conectado com sucesso!\n");

	sensor = digitalRead(7);

	while(1){
	if(sensor == 0){

  //codigo que calcula DATA E HORA
  
  
  
  y2k.tm_hour = 0;   y2k.tm_min = 0; y2k.tm_sec = 0;
  y2k.tm_year = 100; y2k.tm_mon = 0; y2k.tm_mday = 1;

  time(&timer);  /* get current time; same as: timer = time(NULL)  */

  ano = 2000;

  seconds = difftime(timer,mktime(&y2k));

  //printf ("\n\n%.f seconds since January 1, 2000 in the current timezone\n\n", seconds);
  
  min = seconds/60;
  hora = min/60;
  dia = hora/24;
  dias = dia;
  
  while(dias >= 365){
    if ( ( ano % 4 == 0 && ano % 100 != 0 ) || ano % 400 == 0 ){
      ano++;
      dias = dias - 366;
    }
    else{
      ano++;
      dias = dias - 365;
    }	
  }

  if ( ( ano % 4 == 0 && ano % 100 != 0 ) || ano % 400 == 0 )
    diasMes[1] = 29;
  else
    diasMes[1] = 28;

  diaAtual = dias;   
  mesAtual = 0; 

  while(diaAtual > 31){
    
    diaAtual = diaAtual - diasMes[i];  
    mesAtual++;
    i++;
  }
  i = 0;

  horaInt = min/60;
  minInt = seconds/60;
  diaInt = hora/24;

  horaAtual = hora - (diaInt * 24);
  minAtual = min - (horaInt * 60);
  segundoAtual = seconds - (minInt * 60);

  //Fim do codigo que calcula DATA E HORA
	
	//Insere na tabela
	sprintf(query, "INSERT INTO tabela(sensor,dia,mes,ano,hora,min,seg) values('%d','%d','%d','%d','%d','%d','%d');",sensor,diaAtual+1,mesAtual+1,ano,horaAtual,minAtual,segundoAtual);
	res = mysql_query(&conexao, query);
	
	if(!res)
		printf("Registros inseridos %d\n", mysql_affected_rows(&conexao));
	else
		printf("Erro na insercao %d : %s\n", mysql_errno(&conexao),mysql_error(&conexao));
	//Consulta a tabela

	if(mysql_query(&conexao,queryConsult))
		printf("Erro:%s\n", mysql_error(&conexao));
	
	else{

	resp = mysql_store_result(&conexao);

	if(resp){
		campos = mysql_fetch_fields(resp);
		for(count=0;count<mysql_num_fields(resp);count++){
			printf("%s",(campos[count]).name);
			if(mysql_num_fields(resp)>1)
				printf("\t");
		}
	
		printf("\n");
	
	while((linhas=mysql_fetch_row(resp)) != NULL){
		
		for(count=0;count<mysql_num_fields(resp);count++)
			printf("%s\t",linhas[count]);
		printf("\n");



	}
	}

	mysql_free_result(resp);

	while(sensor == 0)
	    sensor = digitalRead(7);
	while(sensor == 1)
	    sensor = digitalRead(7);
	sleep(1);
	
	}
	}
	else
	 sensor = digitalRead(7);
	}

	mysql_close(&conexao);
	
	}
	else{
	
	printf("Falha de conexao!\n");
	printf("Erro %d : %s\n",mysql_errno(&conexao),mysql_error(&conexao));
	
	}

	





}